<?php
class Ameex_Insurance_Block_Adminhtml_Company_UpdateFormContainer_Edit_Tab_Form extends Mage_Adminhtml_Block_Widget_Form
{
	protected function _prepareForm()
	{
		$form = new Varien_Data_Form();
		$this->setForm($form);
		$fieldset = $form->addFieldset('insurancecompany_form', array('legend'=>Mage::helper('ameex_insurance')->__('Update Company Information')));

		$fieldset->addField('email', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('E-mail'),
			'name'      => 'email',
			'class'		=> 'validate-email'
		));
		
		$fieldset->addField('orders_per_cycle', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Orders Per Cycle'),
			'name'      => 'orders_per_cycle',
			'class'		=> 'validate-zero-or-greater',
			'class'		=> 'validate-digits',
		));

		$fieldset->addField('status', 'select', array(
			'label'     => Mage::helper('ameex_insurance')->__('Status'),
			'name'      => 'status',
			'values' => Mage::getModel('ameex_insurance/options')->getEnableDisable(),
        ));

		$fieldset->addField('company_ids', 'hidden', array(
			'name'      => 'company_ids',
			'value'		=> Mage::getSingleton('adminhtml/session')->getCompanyIds(),
		));
			
		return parent::_prepareForm();
	}
}
