<?php

class Ameex_Insurance_ClaimController extends Mage_Core_Controller_Front_Action
{
	public function indexAction()
	{
		$data = $this->getRequest()->getParams();
		$imei = $data[device];
		$activationData = Mage::getModel("ameex_insurance/activationDetails")->getCollection()->addFieldToFilter("imei",$imei);
		if(count($activationData) == 0) {

			/********************
			*	IMEI not activated
			********************/
			
			Mage::getSingleton("core/session")->addError("The IMEI number that you have entered is not yet activated for insurance.");
        	$this->_redirect('*/*/result');
		}
		else {

			/********************
			*	IMEI activated
			********************/

			$activation = $activationData->getFirstItem();
			$purchasedOn = $activation->getCreatedAt();
			$activatedOn = $activation->getActivatedAt();
			$timeTakenForActivation = strtotime($activatedOn) - strtotime($purchasedOn);
			$actualActivationDate = ($timeTakenForActivation <= 2592000 || $timeTakenForActivation <= 5184000) ? $activatedOn : (strtotime($purchasedOn) + 2592000);
			$_SESSION['isLesthan30DAYS'] = $insurancePeriodExceeded = ((time() - strtotime($actualActivationDate)) > 31536000) ? true : false;

			if ($insurancePeriodExceeded) {
				
				/********************
				*	Outside Insurance period
				********************/
				$this->saveclaimAction();
				Mage::getSingleton("core/session")->addError("Your insurance period expired.");
        		$this->_redirect('*/*/result');
				
			} else {
				
				/********************
				*	Within the Insurance period
				********************/

				$isMinimumPeriodExceeded = ((time() - strtotime($actualActivationDate)) > 2592000) ? true : false;
				if ($isMinimumPeriodExceeded) {
					
					/********************
					*	Minimum waiting period exceeded
					********************/
					if($data["type-of-damage"]!="Screen Damage" || $data["type-of-damage"]!="Water Damage"){
					  $transactionStatus = $this->_processCard($data);
					}
				
					
					if ($transactionStatus[0] == 1) {
						
						/********************
						*	Transaction success.
						********************/

						$claim = Mage::getModel("ameex_insurance/claimDetails");
						$claim->setFirstName($data["first-name"]);
					    $claim->setLastName($data["last-name"]);
					    $claim->setEmail($data["email"]);
					    $claim->setDeviceNumber($data["device"]);
					    $claim->setPrimaryPhone($data["primary-phone"]);
					    $claim->setAlternatePhone($data["alternate-phone"]);
					    $claim->setAddress1($data["address-1"]);
					    $claim->setCity($data["city"]);
					    $claim->setState($data["state"]);
					    // $claim->setPolicyNumber($data["policy"]);
					    $claim->setAddress2($data["address-2"]);
					    $claim->setZipcode($data["zip"]);
					    $claim->setCountry($data["country"]);
					    $claim->setDamagedAt($data["date-of-damage"]);
					    $claim->setDamageType($data["type-of-damage"]);						
					    $claim->setDeviceWork($data["does-your-device-still-work"]);
					    $claim->setDescription($data["description-of-incident"]);
						$claim->setDamageMonth($data["type-of-damage_month"]);						
						$claim->setWarranty($data["warranty_type"]);
						$claim->setNotSure($data["not_sure"]);
						$claim->setOver30days($data["over_30_days"]);
						$claim->setPhoneModel($data["phone_model"]);						
						$claim->setLess60days($data["less_than_60_days"]);						
						$_SESSION['uniqedevice'] = $data["device"];					
					    ($data["type-of-damage"] == "Case Damage") ? $claim->setAmountPaid(5.95) : $claim->setAmountPaid(35.00);
						//$claim->setAmountPaid(35.00);
					    //$claim->setAgreeAdditionalCharge($data["additional-5-95-charge"]);
					    $claim->setClaimedAt(time());
					    $claim->save();

					    /********************
						*	To customer
						********************/
						if($data["type-of-damage"] == "Case Damage"){
						$this->sendCaseCustomerMail();
						}else{
						$this->sendCustomerMail();
						}
						//$customerEmail = $claim->getEmail();
						
						// mail($customerEmail, 'We received your claim request.', "We received your claim request.");

						/********************
						*	To Insurance Company
						********************/
						//$this->SendInsusCompemailAction();
						$activationDetailsForThisImei = Mage::getModel("ameex_insurance/activationDetails")->load($claim->getDeviceNumber(),"imei");						
						$insuranceCompany = Mage::getModel("ameex_insurance/company")->load($activationDetailsForThisImei->getInsuranceCompanyId());
						
						
						// mail($insuranceCompany->getEmail(), 'One claim request arrived', "One claim request arrived");

						/********************
						*	To admin
						********************/
						
						$adminEmail = Mage::getStoreConfig('trans_email/ident_general/email');						
						$this->sendAdminMail($adminEmail);
						$additionalCharge = ($data["additional-5-95-charge"] == "OK") ? "Customer agreed for additional charge." : "Customer not agreed for additional charge.";
						// mail($adminEmail, "One claim request arrived and the Insurance company notified. ".$additionalCharge, "One claim request arrived and the Insurance company notified. ".$additionalCharge);

					    Mage::getSingleton("core/session")->addSuccess("Thank you for your payment. You will shortly receive an email with further instructions on how to complete the claim process.");
			        	$this->_redirect('*/*/result');
					} else {
						
						/********************
						*	Transaction failed.
						********************/
                         $this->saveclaimAction();
						//$error = "There was an error processing your request. Please try again or contact our support. We thank you!<br />Error: ".$transactionStatus[3];
						Mage::getSingleton("core/session")->addError($error);
			        	$this->_redirect('*/*/result');	
					}	
				} else {
					
					/********************
					*	Still within the Minimum waiting period
					********************/
					$this->saveclaimAction();
					Mage::getSingleton("core/session")->addError("You have activated your ShieldX2 protection on ".date('m/d/Y',strtotime($actualActivationDate)).". Before submitting a claim, you have to wait for 30 days after Activation.");
			        $this->_redirect('*/*/result');	
				}
			}			
		}
	}




	public function resultAction()
	
	{	  
		if(@$_SESSION['isLesthan30DAYS']){
			Mage::getSingleton("core/session")->addSuccess($this->set_html_value());
		}
		   $this->loadLayout();
		   $this->renderLayout();		
	}

	private function _processCard($data) {
		$seed = time();
        $post_values = array(
            "x_login" => "87tmGXBU8QH",
            "x_tran_key" => "96sj8M5s8PD87d2C",
            "x_version" => "3.1",
            "x_delim_data" => "TRUE",
            "x_delim_char" => "|",
            "x_relay_response" => "FALSE",
            "x_type" => "AUTH_CAPTURE",
            "x_method" => "CC",
            "x_card_num" => $data["number-cc"],
            "x_exp_date" => $data["exp-month-cc"] . $data["exp-year-cc"],
            "x_amount" => ($data["type-of-damage"] == "Case Damage") ? "5.95" : "35.00",
			//"x_amount" =>"35.00",
            "x_description" => "Claim #: " . $seed,
            "x_first_name" => $data["first-name-cc"],
            "x_last_name" => $data["last-name-cc"],
            "x_address" => $data["address-1"] . " " . $data["address-2"],
            "x_state" => $data["state"],
            "x_zip" => $data["zip"],
            "x_country" => $data["country"]
        );
        $post_string = "";
        foreach($post_values as $key=>$value) {
            $post_string .= "$key=" . urlencode($value) . "&";
        }
        $post_string = rtrim($post_string,"& ");
        //$request = curl_init("https://secure.authorize.net/gateway/transact.dll");
        $request = curl_init("https://test.authorize.net/gateway/transact.dll");
        curl_setopt($request,CURLOPT_HEADER,0);
        curl_setopt($request,CURLOPT_RETURNTRANSFER,1);
        curl_setopt($request,CURLOPT_POSTFIELDS,$post_string);
        curl_setopt($request,CURLOPT_SSL_VERIFYPEER,FALSE);
        $post_response = curl_exec($request);
        curl_close($request);
        $response_array = explode($post_values["x_delim_char"],$post_response);
        return $response_array;
    }
	protected function set_html_value()
	{
		//$_POST['uniqedevice']='355876061361584';
		$connection = Mage::getSingleton('core/resource')->getConnection('core_read');
		
		$select=$connection->query("SELECT * FROM `insurance_claim_details` WHERE device_number='".@$_SESSION['uniqedevice']."' ORDER BY `id` DESC LIMIT 0,1");
		/*$select = $connection->select()
		->from('insurance_claim_details', array('*'))
		->where('device_number=?',@$_SESSION['uniqedevice']);	
		*/
		
		// group by name
		$rowsArray = $select->fetch(); // return all rows
		//$rowArray =$connection->fetchRow($select);   //return row
		 Mage::register('selectItem', $rowsArray);
		// echo "<pre>";
		 //print($rowsArray['country']);
		
		
		
		//$html = '<strong>supplier details : <span style="text-align:right"><input type="button" onclick="window.print();" value="print packaging slip" /></span></strong>
//<table width="500" border="1">
//<tr><td colspan="2"></td></tr>
//  <tr>
//    <td width="225"><strong>Supplier Name</strong></td>
//    <td width="259">Supplier </td>
//   
//  </tr>
//  <tr>
//      <td>Supplier Email</td>
//    <td>Supplier@shieldx2.com</td>
//   
//  </tr>
//  <tr>
//      <td>Supplier Phone</td>
//    <td>1234567892</td>
//   
//  </tr>
//</table>
//<strong>Customer Details : </strong><br>
//<table width="500" border="1">
//  <tr>
//    <td width="227">Name</td>
//    <td width="257">'.$rowsArray['first_name'].'</td>
//   
//  </tr>
//  <tr>
//      <td>IMEI</td>
//    <td>'.$rowsArray['device_number'].'</td>
//   
//  </tr>
//  <tr>
//      <td>Adress</td>
//    <td>'.$rowsArray['address1'].'</td>
//   
//  </tr>
//   <tr>
//      <td>City</td>
//    <td>'.$rowsArray['city'].'</td>
//   
//  </tr> 
// <tr>
//      <td>State</td>
//    <td>'.$rowsArray['state'].'</td>
//   
//  </tr>
//   <tr>
//      <td>Zip Code</td>
//    <td>'.$rowsArray['zipcode'].'</td>
//   
//  </tr> 
//   <tr>
//      <td>Country</td>
//    <td>'.$rowsArray['country'].'</td>
//   
//  </tr>
//   <tr>
//      <td>Damage Type</td>
//    <td>'.$rowsArray['damage_type'].'</td>
//   
//  </tr>
//   <tr>
//      <td>Device Work</td>
//    <td>'.$rowsArray['device_work'].'</td>
//   
//  </tr>
//   <tr>
//      <td>Phone Model </td>
//    <td>'.$rowsArray['phone_model'].'</td>
//   
//  </tr>
//  <tr>
//      <td>warranty</td>
//    <td>'.$rowsArray['warranty'].'</td>   
//  </tr>
//</table>';
unset($_SESSION['uniqedevice']);
 return $html;
	}
protected function sendAdminMail($sendTo)
{
	$storeData =  $this->getemailAddressForms();
	//$to=$sendTo;	
	//$to='yashsantosh.singh@gmail.com';
	$to='claims@shieldx2.com';
	$subject="Claim Alert Form";
	$message='<h3 align="center">Claim Alert Form</h3>
			<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Mail Format</title>
</head>

<body>
<table cellpadding="0" cellspacing="0" border="0" width="700" align="center" style="border:solid 1px #DDDDDD">
  <tbody>
    <tr>
      <td valign="middle" height="30" style="background-color:#EBEBEB"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong><strong>Dear Administrator,</strong><br>You have received a claim !</strong></span></td>
    </tr>
    <tr>
      <td valign="top" style="padding:15px 0"><table cellpadding="0" cellspacing="0" border="0" width="100%" align="center">
          <tbody>
            <tr>
              <td width="50%" valign="top"><table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Customer</strong></span></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['FirstNane'].'</span></span></td>
                    </tr>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Address</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['address1'].' , '.$storeData['address2'].' , '.$storeData['city'].' , '.$storeData['country'].'</span></td>
                    </tr>
                  </tbody>
                </table></span></td>
              <td valign="top"><table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                      <td valign="top" width="100"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Email</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['EmailAdress'].'</span></td>
                    </tr>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Phone 1</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['primary_phone'].'</span></td>
                    </tr>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Phone 2</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['alternate_phone'].'</span></td>
                    </tr>
                  </tbody>
                </table></span></td>
            </tr>
          </tbody>
        </table></span></td>
    </tr>
    <tr>
   <td valign="middle" height="30" style="background-color:#EBEBEB"><span style="font-family:Arial, sans-serif; font-size:12px;">&nbsp;&nbsp;&nbsp;<strong>Phone Details</strong></span></td>
    </tr>
    <tr>
      <td valign="top">
      <table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>IMEI</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['device_number'].'</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Phone Type</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['phone_model'].'</span></td>                    
                    </tr>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Type of Damage</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['damage_type'].'</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Does your Device still work</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['device_work'].'</span></td>
                    </tr>
                    </tbody>
                    </table>
      </span></td>
    </tr>
    <tr>
    <td valign="top">
          <table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                    <td width="18%" valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Description of Incident</strong></span></td>
                    <td width="82%" valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['description'].'</span></td>
                    </tr>
                    </tbody>
                    </table>
                    </span></td>
    </tr>
    
    
    <tr>
      <td valign="top">
      <table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                   <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Date Device Registered</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['claimed_at'].'</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Warranty</strong> </span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['warranty'].'</span></td> 
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Not Sure</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['not_sure'].'</span></td>   
                    </tr>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Processing Fee paid</strong> </span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.(($storeData['amount_paid']>0)?'Yes':'No').'</span></td>
                    <td colspan="3"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Additional fee paid for New Case<strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.(($storeData['agree_additional_charge']=='OK')?'Yes':'No').'</span></td> 
                    </tr>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Unit Shipped to</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">SBE</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Date</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.date('Y-m-d').'</span></td> 
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"></span></td> 
                    </tr>
                    </tbody>
                    </table>
      </span></td>
    </tr>
  </tbody>
</table>
</body>
</html>
 ';					
	 
	
	$name = $storeData['FirstNane'];
	$email = $storeData['EmailAdress'];
	$headers  = 'MIME-Version: 1.0' . "\r\n";
	$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
	$headers .= 'From:' .$name.' <'.$email.'>' . "\r\n";
	@mail($to, $subject, $message, $headers);
		
	}
	protected function sendCustomerMail()
	{		
    $storeData =  $this->getemailAddressForms();
	$email = $storeData['EmailAdress'];	
	$name = 'shieldx2';	
	$to=$email;		
	//$to='yash@redcubedigital.com';	
	$subject="Claim Alert Form Customer";
	$message='	
	

			<div style="padding:5px 5px 5px 5 px;">
<h1 align="center">Restore your Mobile Life!</h1>
<h1 align="center"><u>CLAIMS PROCESS</u></h1>
<p>Dear '.$storeData['FirstNane'].',</p>
<p>We are sorry to hear about your phone, however, dont worry, we will now arrange for your phone to be repaired.</p>
<br />
<p><strong>To help us process  your claim as quickly as possible please follow the instructions below.</strong></p>
<ol type="1">
	<li><strong><u>Getting started!</u></strong>
	  <ol type="a">
	    <li>You will be receiving a prepaid label through the post in the next 3 working days. If it has not arrived, please contact 0044 7967 500 952 </li>
	    <li>Place your damaged device and your Shieldx2 case in a padded envelope or suitable package.</li>
	    <li>If you are claiming for an Apple product please ensure you enclose the SIM tray and <span style="color:#a40703">REMOVE YOUR ICLOUD ACCOUNT FROM THE DEVICE</span>.  Please copy and paste  the link below into your browser window, should you require any further assistance:
			<a href="https://support.apple.com/kb/PH19302?viewlocale=en_GB&locale=en_GB">(https://support.apple.com/kb/PH19302?viewlocale=en_GB&locale=en_GB )</a>
</li>
	    <li>Please make sure you include the battery but no other accessories</li>
	    <li>Where possible, you should make a back-up and delete any data stored on the device as it will be wiped as part of the repair process - please refer to your handset instructions for advice on how to do this.</li>
        <li>Please do not send any SIM or memory cards</li>
      </ol>
    </li>
    <li><strong><u>What happens when we receive your phone and Shieldx2 case?</u></strong>
      <ol type="a">
        <li>We will aim to repair and dispatch your device within 3 working days from when our Repair Center receives it. Please be aware that during the repair process, we will not repair any cosmetic damage or damage that has been caused by wear and tear. </li>
        <li>Once your device has been repaired, it will be sent to you by overnight delivery and will need to be signed for. You will receive an email from Shieldx2 confirming your delivery details.</li>
      </ol>    
    </li>
     <li><strong><u>What happens if we cannot repair your phone?</u></strong>
    <ol type="a">
    	<li>a.	If we are unable to repair your device then we will send you a replacement which may be a refurbished/remanufactured like for like device.</li>
        <li>b.	If we dont have the same make and model in stock we will contact you to discuss the other options available to settle your claim.</li>
        <li><strong>One of our claim representatives will tell you the next steps, if we need to replace your phone.</strong> See more at online at <a href="http://www.Shieldx2.com/claims" target="_blank" >http://www.Shieldx2.com/claims</a></li>
    </ol>    
    </li>
    
 </ol>
</div>';
			
	
	$headers  = 'MIME-Version: 1.0' . "\r\n";
	$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
	$headers .= 'From:' .$name.' <'.$email.'>' . "\r\n";
	@mail($to, $subject, $message, $headers);
		
	}	
	
	protected function sendCaseCustomerMail()
	{		
    $storeData =  $this->getemailAddressForms();
	$email = $storeData['EmailAdress'];	
	$name = 'shieldx2';	
	$to=$email;		
	//$to='gt7772@gmail.com';	
	$subject="Claim Alert Form Customer Case Damage";
	$message='	
	

			<div style="padding:5px 5px 5px 5 px;">
<h1 align="center">Restore your Mobile Life!</h1>
<p>Well the good news is that your Shieldx2 phone case has worked and protected you phone.  Think what would happen to your phone without it on?  We will be sending out your new case today and tracking number to you.   </p>
<br />
<p><strong>Thank you for being a Shieldx2 customer</strong></p>

</div>';
			
	
	$headers  = 'MIME-Version: 1.0' . "\r\n";
	$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
	$headers .= 'From:' .$name.' <'.$email.'>' . "\r\n";
	@mail($to, $subject, $message, $headers);
		
	}	
	
	
	protected function saveclaimAction()
	{
		$claim = Mage::getModel("ameex_insurance/claimDetails");
		$claim->setFirstName($_REQUEST["first-name"]);
		$claim->setLastName($_REQUEST["last-name"]);
		$claim->setEmail($_REQUEST["email"]);
		$claim->setDeviceNumber($_REQUEST["device"]);
		$claim->setPrimaryPhone($_REQUEST["primary-phone"]);
		$claim->setAlternatePhone($_REQUEST["alternate-phone"]);
		$claim->setAddress1($_REQUEST["address-1"]);
		$claim->setCity($_REQUEST["city"]);
		$claim->setState($_REQUEST["state"]);
		// $claim->setPolicyNumber($data["policy"]);
		$claim->setAddress2($_REQUEST["address-2"]);
		$claim->setZipcode($_REQUEST["zip"]);
		$claim->setCountry($_REQUEST["country"]);
		$claim->setDamagedAt($_REQUEST["date-of-damage"]);
		$claim->setDamageType($_REQUEST["type-of-damage"]);						
		$claim->setDeviceWork($_REQUEST["does-your-device-still-work"]);
		$claim->setDescription($_REQUEST["description-of-incident"]);
		$claim->setDamageMonth($_REQUEST["type-of-damage_month"]);
		$claim->setPhoneModel($_REQUEST["phone_model"]);
		$claim->setWarranty($_REQUEST["warranty_type"]);
		$claim->setNotSure($_REQUEST["not_sure"]);
		$claim->setOver30days($_REQUEST["over_30_days"]);
		$claim->setLess60days($_REQUEST["less_than_60_days"]);
		$_SESSION['uniqedevice'] = $_REQUEST["device"];	
		$claim->setClaimedAt(time());
		$claim->save();
		
	}
	public function SendInsusCompemailAction()
	{
				
		
		$storeData =  $this->getemailAddressForms();
		$name = $storeData['FirstNane'];
		$email = $storeData['EmailAdress'];	
		$to = 'yash@redcubedigital.com';	
		//$to = 'cperle@shieldx2.com';	
		$subject="Claim Alert insurance company";
		
		$message='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Mail Format</title>
</head>

<body>
<table cellpadding="0" cellspacing="0" border="0" width="700" align="center" style="border:solid 1px #DDDDDD">
  <tbody>
    <tr>
      <td valign="middle" height="30" style="background-color:#EBEBEB"><span style="font-family:Arial, sans-serif; font-size:12px;">&nbsp;&nbsp;&nbsp;<strong>You have received a claim !</strong></span></td>
    </tr>
    <tr>
      <td valign="top" style="padding:15px 0"><table cellpadding="0" cellspacing="0" border="0" width="100%" align="center">
          <tbody>
            <tr>
              <td width="50%" valign="top"><table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Customer</strong></span></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['FirstNane'].'</span></span></td>
                    </tr>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Address</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['address1'].'&nbsp;'.$storeData['address2'].'&nbsp'.$storeData['city'].'&nbsp'.$storeData['country'].'</span></td>
                    </tr>
                  </tbody>
                </table></span></td>
              <td valign="top"><table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                      <td valign="top" width="100"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Email</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['EmailAdress'].'</span></td>
                    </tr>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Phone 1</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['primary_phone'].'</span></td>
                    </tr>
                    <tr>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Phone 2</strong></span></td>
                      <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['alternate_phone'].'</span></td>
                    </tr>
                  </tbody>
                </table></span></td>
            </tr>
          </tbody>
        </table></span></td>
    </tr>
    <tr>
   <td valign="middle" height="30" style="background-color:#EBEBEB"><span style="font-family:Arial, sans-serif; font-size:12px;">&nbsp;&nbsp;&nbsp;<strong>Phone Details</strong></span></td>
    </tr>
    <tr>
      <td valign="top">
      <table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>IMEI</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['device_number'].'</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Phone Type</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['phone_model'].'</span></td>                    
                    </tr>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Type of Damage</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['damage_type'].'</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Does your Device still work</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['device_work'].'</span></td>
                    </tr>
                    </tbody>
                    </table>
      </span></td>
    </tr>
    <tr>
    <td valign="top">
          <table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Description of Incident</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['description'].'</span></td>
                    </tr>
                    </tbody>
                    </table>
                    </span></td>
    </tr>
    
    
    <tr>
      <td valign="top">
      <table cellpadding="0" cellspacing="10" border="0" width="100%" align="center">
                  <tbody>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Date Device Registered</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['claimed_at'].'</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Warranty</strong> </span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['warranty'].'</span></td> 
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Not Sure</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.$storeData['not_sure'].'</span></td>                   
                    </tr>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Processing Fee paid</strong> </span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.(($storeData['amount_paid']>0)?'Yes':'No').'</span></td>
                    <td colspan="3"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Additional fee paid for New Case<strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.(($storeData['agree_additional_charge']=='OK')?'Yes':'No').'</span></td> 
                    </tr>
                    <tr>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Unit Shipped to</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">SBE</span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"><strong>Date</strong></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;">'.date('Y-m-d').'</span></td> 
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"></span></td>
                    <td valign="top"><span style="font-family:Arial, sans-serif; font-size:12px;"></span></td> 
                    </tr>
                    </tbody>
                    </table>
      </span></td>
    </tr>
  </tbody>
</table>
</body>
</html>
 ';
		
		
		
		
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		$headers .= 'From:' .$name.' <'.$email.'>' . "\r\n";
		@mail($to, $subject, $message, $headers);
		
	}
	protected function getemailAddressForms()
	{
		$connection = Mage::getSingleton('core/resource')->getConnection('core_read');
		/*$select = $connection->select()
		->from('insurance_claim_details', array('*'))
		->where('device_number=?',@$_SESSION['uniqedevice']);*/	
		$select=$connection->query("SELECT * FROM `insurance_claim_details` WHERE device_number='".@$_SESSION['uniqedevice']."' ORDER BY `id` DESC LIMIT 0,1");
		// group by name
		$rowsArray = $select->fetch(); // return all rows
		//$rowArray =$connection->fetchRow($select);   //return row
		// Mage::register('selectItem', $rowsArray);
		 
		 
		 $arr =  array('FirstNane'=>$rowsArray['first_name'],
		               'EmailAdress'=>$rowsArray['email'],
					    'address1'=>$rowsArray['address1'],
						'device_number'=>$rowsArray['device_number'],
						'city'=>$rowsArray['city'],
						'state'=>$rowsArray['state'],
						'zipcode'=>$rowsArray['zipcode'],
						'damage_type'=>$rowsArray['damage_type'],
						'device_work'=>$rowsArray['device_work'],
						'country'=>$rowsArray['country'],
						'phone_model'=>$rowsArray['phone_model'],
						'primary_phone'=>$rowsArray['primary_phone'],
						'alternate_phone'=>$rowsArray['alternate_phone'],
						'address2'=>$rowsArray['address2'],
						'iemi_numbe'=>$rowsArray['iemi_numbe'],
						'damage_type'=>$rowsArray['damage_type'],
						'amount_paid'=>$rowsArray['amount_paid'],
						'agree_additional_charge'=>$rowsArray['agree_additional_charge'],
						'device_work'=>$rowsArray['device_work'],
						'damage_date'=>$rowsArray['damage_date'],
						'description'=>$rowsArray['description'],
						'warranty'=>$rowsArray['warranty'],	
						'not_sure'=>$rowsArray['not_sure'],		
						'claimed_at'=>$rowsArray['claimed_at'],	
						'over30days'=>$rowsArray['over30days'],
						'less60days'=>$rowsArray['less60days']
						
					   );
		 
		 return $arr;
		
	}
}