<?php
 


class Limex_Advr_Block_Adminhtml_Review_Review extends Limex_Advr_Block_Adminhtml_Block_Container
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Reviews'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('column');

        $this->_initChart()
            ->setXAxisType('datetime')
            ->setXAxisField('period')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('period')
            ->setDefaultDir('desc')
            ;

        return $this;
    }

    protected function _prepareToolbar()
    {
        $this->_initToolbar()
            ->setRangesVisibility(true)
            ->setCompareVisibility(false)
            ;

        return $this;
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_reviews')
            ->setBaseTable('review/review')
            ->setFilterData($this->getFilterData())
            ->selectColumns($this->getVisibleColumns())
            ->groupByColumn('period')
            ;

        return $collection;
    }


    public function getColumns()
    {
        $columns = array(
            'period' => array(
                'header'                => 'Period',
                'type'                  => 'text',
                'frame_callback'        => array(Mage::helper('advr/callback'), 'period'),
                'totals_label'          => 'Total',
                'filter_totals_label'   => 'Subtotal',
                'grouped'               => true,
                'filter'                => false,
            ),

            'quantity' => array(
                'header'         => 'Number Of Reviews',
                'type'           => 'number',
                'chart' => true,
            ),
        );

        return $columns;
    }
}