<?php

class Magegiant_Affiliate_Block_Adminhtml_Account_Edit extends Mage_Adminhtml_Block_Widget_Form_Container
{
    public function __construct()
    {
        parent::__construct();

        $this->_objectId   = 'id';
        $this->_blockGroup = 'affiliate';
        $this->_controller = 'adminhtml_account';

        $this->_updateButton('save', 'label', Mage::helper('affiliate')->__('Save Account'));
        $this->_updateButton('delete', 'label', Mage::helper('affiliate')->__('Delete Account'));


        $this->_addButton('saveandcontinue', array(
            'label'   => Mage::helper('adminhtml')->__('Save And Continue Edit'),
            'onclick' => 'saveAndContinueEdit()',
            'class'   => 'save',
        ), -100);

        $alert      = '';
        $paymentUrl = '';

        $data    = Mage::registry('account_data');
        $storeId = $this->getRequest()->getParam('store');
        if ($data && $data['status'] == 1) {
            // $methodPaypalPayment = Mage::getStoreConfig('affiliate/payment/payment_method');
            $accountId = $this->getRequest()->getParam('id');

            // $waitingPayment = Mage::getModel('affiliate/payment')->getCollection()
            // ->addFieldToFilter('account_id', $accountId)
            // ->addFieldToFilter('status', 1) //waiting
            // ->getFirstItem();

            // if($methodPaypalPayment != 'api' || count(Mage::helper('affiliate/payment')->getAvailablePaymentCode()) != 1){
            // if($waitingPayment->getId()){
            // $paymentUrl = $this->getUrl('affiliateadmin/adminhtml_payment/edit', array('id' => $waitingPayment->getId(), 'store' => $storeId));
            // Mage::getSingleton('core/session')->addNotice(Mage::helper('affiliate')->__('This account has one payment waiting need to be processed.'));
            // }else
            // $paymentUrl = $this->getUrl('affiliateadmin/adminhtml_payment/new', array('account_id' => $accountId, 'store' => $storeId));

            // $label = Mage::helper('affiliate')->__('Add payout');

            // }
            // else{
            // if($waitingPayment->getId()){
            // $paymentUrl = $this->getUrl('affiliateadmin/adminhtml_payment/edit', array('id' => $waitingPayment->getId(), 'store' => $storeId));
            // Mage::getSingleton('core/session')->addNotice(Mage::helper('affiliate')->__('This account has one payment waiting need to be processed.'));
            // }else
            // $paymentUrl = $this->getUrl('affiliateadmin/adminhtml_payment/new', array('account_id' => $accountId, 'store' => $storeId, 'method' => 'api'));

            // $label = Mage::helper('affiliate')->__('Payout');

            // }

            $paymentRelease = Mage::getStoreConfig('affiliate/payment/payment_release', $storeId);
            // $isBalanceIsGlobal = Mage::helper('affiliate')->isBalanceIsGlobal();
            //$alert = Mage::helper('affiliate')->__('Are you sure of paying out for this account?');
            $paymentUrl = $this->getUrl('affiliateadmin/adminhtml_payment/new', array(
                'account_id' => $accountId,
                'store'      => $storeId,
            ));
            if ($data['balance'] > 0 && $data['balance'] >= $paymentRelease) {
                $this->_addButton('payment', array(
                    'label'   => Mage::helper('affiliate')->__('Payout'), // $label,
                    'onclick' => "location.href = '$paymentUrl'",
                ), -200);
            }
        }

        $this->_formScripts[] = "
            function toggleEditor() {
                if (tinyMCE.getInstanceById('affiliate_content') == null) {
                    tinyMCE.execCommand('mceAddControl', false, 'affiliate_content');
                } else {
                    tinyMCE.execCommand('mceRemoveControl', false, 'affiliate_content');
                }
            }

            function saveAndContinueEdit(){
                editForm.submit($('edit_form').action+'back/edit/');
            }
			
			function payment(isAddPayout){
				if(isAddPayout){
					location.href = '$paymentUrl';
				}else{
					var answer = confirm('$alert');
					if (answer){
						location.href = '$paymentUrl';
					}
				}
			}
        ";
    }

    public function getHeaderText()
    {
        if (Mage::registry('account_data') && Mage::registry('account_data')->getId()) {
            return Mage::helper('affiliate')->__("Edit Account '%s'", $this->htmlEscape(Mage::registry('account_data')->getName()));
        } else {
            return Mage::helper('affiliate')->__('Add Account');
        }
    }
}